clang 10.0.0git

Public Types | Public Member Functions | Static Public Member Functions | List of all members
clang::comments::ParamCommandComment Class Reference

Doxygen \param command. More...

`#include "clang/AST/Comment.h"`

Inheritance diagram for clang::comments::ParamCommandComment:
[legend]
Collaboration diagram for clang::comments::ParamCommandComment:
[legend]

## Public Types
enum | : unsigned { InvalidParamIndex = ~0U, VarArgParamIndex = ~0U - 1U }
enum | PassDirection { In, Out, InOut }
Public Types inherited from clang::comments::Comment
enum | CommentKind { NoCommentKind = 0 }
typedef Comment *const * | child_iterator

## Public Member Functions
| ParamCommandComment (SourceLocation LocBegin, SourceLocation LocEnd, unsigned CommandID, CommandMarkerKind CommandMarker)
PassDirection | getDirection () const LLVM_READONLY
bool | isDirectionExplicit () const LLVM_READONLY
void | setDirection (PassDirection Direction, bool Explicit)
bool | hasParamName () const
StringRef | getParamName (const FullComment *FC) const
StringRef | getParamNameAsWritten () const
SourceRange | getParamNameRange () const
bool | isParamIndexValid () const LLVM_READONLY
bool | isVarArgParam () const LLVM_READONLY
void | setIsVarArgParam ()
unsigned | getParamIndex () const LLVM_READONLY
void | setParamIndex (unsigned Index)
Public Member Functions inherited from clang::comments::BlockCommandComment
| BlockCommandComment (SourceLocation LocBegin, SourceLocation LocEnd, unsigned CommandID, CommandMarkerKind CommandMarker)
child_iterator | child_begin () const
child_iterator | child_end () const
unsigned | getCommandID () const
StringRef | getCommandName (const CommandTraits &Traits) const
SourceLocation | getCommandNameBeginLoc () const
SourceRange | getCommandNameRange (const CommandTraits &Traits) const
unsigned | getNumArgs () const
StringRef | getArgText (unsigned Idx) const
SourceRange | getArgRange (unsigned Idx) const
void | setArgs (ArrayRef< Argument > A)
ParagraphComment * | getParagraph () const LLVM_READONLY
bool | hasNonWhitespaceParagraph () const
void | setParagraph (ParagraphComment *PC)
CommandMarkerKind | getCommandMarker () const LLVM_READONLY
Public Member Functions inherited from clang::comments::Comment
| Comment (CommentKind K, SourceLocation LocBegin, SourceLocation LocEnd)
CommentKind | getCommentKind () const
const char * | getCommentKindName () const
void | dump () const
void | dumpColor () const
void | dump (const ASTContext &Context) const
void | dump (raw_ostream &OS, const CommandTraits *Traits, const SourceManager *SM) const
SourceRange | getSourceRange () const LLVM_READONLY
SourceLocation | getBeginLoc () const LLVM_READONLY
SourceLocation | getEndLoc () const LLVM_READONLY
SourceLocation | getLocation () const LLVM_READONLY
child_iterator | child_begin () const
child_iterator | child_end () const
unsigned | child_count () const

## Static Public Member Functions
static bool | classof (const Comment *C)
static const char * | getDirectionAsString (PassDirection D)
Static Public Member Functions inherited from clang::comments::BlockCommandComment
static bool | classof (const Comment *C)
Static Public Member Functions inherited from clang::comments::BlockContentComment
static bool | classof (const Comment *C)

## Additional Inherited Members
Protected Types inherited from clang::comments::Comment
enum | { NumCommentBits = 8 }
enum | { NumInlineContentCommentBits = NumCommentBits + 1 }
enum | { NumTextCommentBits = NumInlineContentCommentBits + 2 }
enum | { NumInlineCommandCommentBits }
enum | { NumHTMLTagCommentBits = NumInlineContentCommentBits + 1 }
enum | { NumHTMLStartTagCommentBits = NumHTMLTagCommentBits + 1 }
enum | { NumParagraphCommentBits = NumCommentBits + 2 }
enum | { NumBlockCommandCommentBits }
enum | { NumParamCommandCommentBits = NumBlockCommandCommentBits + 3 }
Protected Member Functions inherited from clang::comments::BlockCommandComment
| BlockCommandComment (CommentKind K, SourceLocation LocBegin, SourceLocation LocEnd, unsigned CommandID, CommandMarkerKind CommandMarker)
Protected Member Functions inherited from clang::comments::BlockContentComment
| BlockContentComment (CommentKind K, SourceLocation LocBegin, SourceLocation LocEnd)
Protected Member Functions inherited from clang::comments::Comment
void | setSourceRange (SourceRange SR)
void | setLocation (SourceLocation L)
Protected Attributes inherited from clang::comments::BlockCommandComment
ArrayRef< Argument > | Args
| Word-like arguments. More...
ParagraphComment * | Paragraph
| Paragraph argument. More...
Protected Attributes inherited from clang::comments::Comment
SourceLocation | Loc
| Preferred location to show caret. More...
SourceRange | Range
| Source range of this AST node. More...
union {
CommentBitfields CommentBits
InlineContentCommentBitfields InlineContentCommentBits
TextCommentBitfields TextCommentBits
InlineCommandCommentBitfields InlineCommandCommentBits
HTMLTagCommentBitfields HTMLTagCommentBits
HTMLStartTagCommentBitfields HTMLStartTagCommentBits
ParagraphCommentBitfields ParagraphCommentBits
BlockCommandCommentBitfields BlockCommandCommentBits
ParamCommandCommentBitfields ParamCommandCommentBits
}; |

## Detailed Description

Doxygen \param command.

Definition at line 713 of file Comment.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum : unsigned

Enumerator
InvalidParamIndex |
VarArgParamIndex |

Definition at line 719 of file Comment.h.

## ◆ PassDirection

enum clang::comments::ParamCommandComment::PassDirection

Enumerator
In |
Out |
InOut |

Definition at line 739 of file Comment.h.

## Constructor & Destructor Documentation

## ◆ ParamCommandComment()

clang::comments::ParamCommandComment::ParamCommandComment | ( | SourceLocation | LocBegin,
|  | SourceLocation | LocEnd,
|  | unsigned | CommandID,
|  | CommandMarkerKind | CommandMarker
| ) |  |
| inline

Definition at line 724 of file Comment.h.

References clang::comments::Comment::ParamCommandCommentBits.

## Member Function Documentation

## ◆ classof()

static bool clang::comments::ParamCommandComment::classof | ( | const Comment * | C | ) |
| inline static

Definition at line 735 of file Comment.h.

References clang::comments::Comment::getCommentKind().

## ◆ getDirection()

PassDirection clang::comments::ParamCommandComment::getDirection | ( |  | ) | const
| inline

Definition at line 747 of file Comment.h.

References clang::comments::Comment::ParamCommandCommentBits.

Referenced by clang::TextNodeDumper::visitParamCommandComment(), and clang::JSONNodeDumper::visitParamCommandComment().

## ◆ getDirectionAsString()

const char * clang::comments::ParamCommandComment::getDirectionAsString | ( | PassDirection | D | ) |
| static

Definition at line 192 of file Comment.cpp.

References In, InOut, and Out.

Referenced by clang::comments::Sema::actOnParamCommandDirectionArg(), and clang::TextNodeDumper::visitParamCommandComment().

## ◆ getParamIndex()

unsigned clang::comments::ParamCommandComment::getParamIndex | ( |  | ) | const
| inline

Definition at line 787 of file Comment.h.

Referenced by clang::TextNodeDumper::visitParamCommandComment(), and clang::JSONNodeDumper::visitParamCommandComment().

## ◆ getParamName()

StringRef clang::comments::ParamCommandComment::getParamName | ( | const FullComment * | FC | ) | const

Definition at line 371 of file Comment.cpp.

References clang::comments::FullComment::getDeclInfo(), and clang::comments::DeclInfo::ParamVars.

Referenced by clang::TextNodeDumper::visitParamCommandComment(), and clang::JSONNodeDumper::visitParamCommandComment().

## ◆ getParamNameAsWritten()

StringRef clang::comments::ParamCommandComment::getParamNameAsWritten | ( |  | ) | const
| inline

Definition at line 766 of file Comment.h.

Referenced by clang::comments::Sema::resolveParamCommandIndexes(), clang::TextNodeDumper::visitParamCommandComment(), and clang::JSONNodeDumper::visitParamCommandComment().

## ◆ getParamNameRange()

SourceRange clang::comments::ParamCommandComment::getParamNameRange | ( |  | ) | const
| inline

Definition at line 770 of file Comment.h.

Referenced by clang::comments::Sema::resolveParamCommandIndexes().

## ◆ hasParamName()

bool clang::comments::ParamCommandComment::hasParamName | ( |  | ) | const
| inline

Definition at line 760 of file Comment.h.

Referenced by clang::comments::Sema::resolveParamCommandIndexes(), clang::TextNodeDumper::visitParamCommandComment(), and clang::JSONNodeDumper::visitParamCommandComment().

## ◆ isDirectionExplicit()

bool clang::comments::ParamCommandComment::isDirectionExplicit | ( |  | ) | const
| inline

Definition at line 751 of file Comment.h.

References clang::comments::Comment::ParamCommandCommentBits.

Referenced by clang::comments::Sema::actOnParamCommandParamNameArg(), clang::TextNodeDumper::visitParamCommandComment(), and clang::JSONNodeDumper::visitParamCommandComment().

## ◆ isParamIndexValid()

bool clang::comments::ParamCommandComment::isParamIndexValid | ( |  | ) | const
| inline

Definition at line 774 of file Comment.h.

Referenced by clang::TextNodeDumper::visitParamCommandComment(), and clang::JSONNodeDumper::visitParamCommandComment().

## ◆ isVarArgParam()

bool clang::comments::ParamCommandComment::isVarArgParam | ( |  | ) | const
| inline

Definition at line 778 of file Comment.h.

Referenced by clang::TextNodeDumper::visitParamCommandComment(), and clang::JSONNodeDumper::visitParamCommandComment().

## ◆ setDirection()

void clang::comments::ParamCommandComment::setDirection | ( | PassDirection | Direction,
|  | bool | Explicit
| ) |  |
| inline

Definition at line 755 of file Comment.h.

References clang::comments::Comment::ParamCommandCommentBits.

Referenced by clang::comments::Sema::actOnParamCommandDirectionArg(), and clang::comments::Sema::actOnParamCommandParamNameArg().

## ◆ setIsVarArgParam()

void clang::comments::ParamCommandComment::setIsVarArgParam | ( |  | ) |
| inline

Definition at line 782 of file Comment.h.

Referenced by clang::comments::Sema::resolveParamCommandIndexes().

## ◆ setParamIndex()

void clang::comments::ParamCommandComment::setParamIndex | ( | unsigned | Index | ) |
| inline

Definition at line 793 of file Comment.h.

Referenced by clang::comments::Sema::resolveParamCommandIndexes().

The documentation for this class was generated from the following files:

- include/clang/AST/Comment.h
- lib/AST/Comment.cpp